unit Packmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Gauge95, FileCtrl, DB,
  DBTables, TablPack;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    Label1: TLabel;
    Label2: TLabel;
    L_status: TLabel;
    Btn_pack: TBitBtn;
    Btn_packall: TBitBtn;
    Btn_about: TBitBtn;
    Btn_exit: TBitBtn;
    FilterComboBox1: TFilterComboBox;
    TablePack1: TTablePack;
    Btn_check: TBitBtn;
    Btn_checkall: TBitBtn;
    procedure Btn_exitClick(Sender: TObject);
    procedure Btn_aboutClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure Btn_packClick(Sender: TObject);
    procedure Btn_packallClick(Sender: TObject);
    procedure Btn_checkClick(Sender: TObject);
    procedure Btn_checkallClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses About, PackAll, TRepair;
{$R *.DFM}

procedure TForm1.Btn_exitClick(Sender: TObject);
begin
   Close;
end;

procedure TForm1.Btn_aboutClick(Sender: TObject);
begin
   AboutBox.ShowModal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   FileListBox1.Mask := FilterComboBox1.Mask;
end;

procedure TForm1.FileListBox1Change(Sender: TObject);
begin
   L_status.Caption := FileListBox1.FileName;
   Btn_pack.Enabled := FileListBox1.ItemIndex <> -1;
   Btn_check.Enabled := (Btn_pack.Enabled) and
            (FilterComboBox1.ItemIndex = 0);  { only Paradox table }
   Btn_packall.Enabled := FileListBox1.Items.Count > 0;
   Btn_checkall.Enabled := (Btn_packall.Enabled) and
            (FilterComboBox1.ItemIndex = 0);
end;

procedure TForm1.Btn_packClick(Sender: TObject);
begin
   L_status.Caption := 'Packing '+ExtractFileName(FileListBox1.FileName)
                       + ' ...';
   L_status.Refresh;
   Screen.Cursor := crHourGlass;
   try
      TablePack1.TableName := FileListBox1.FileName;
      try
         TablePack1.Open;
         TablePack1.Pack;
      except
         L_status.Caption :=
               'Pack '+ExtractFileName(FileListBox1.FileName)+': Failed';
         MessageDlg(Exception(ExceptObject).Message, mtError, [mbOk], 0);
      end;
      L_status.Caption :=
            'Pack '+ExtractFileName(FileListBox1.FileName) + ': Success';
   finally
      Screen.Cursor := crDefault;
      TablePack1.Close;
   end;
end;

procedure TForm1.Btn_packallClick(Sender: TObject);
var report: string;
begin
   Dlg_packall.Files := FileListBox1;
   Dlg_packall.TablePack1 := TablePack1;
   Dlg_packall.Tag := 0; { Pack identify }
   Dlg_packall.ShowModal;
   report := IntToStr(Dlg_packall.good)+ ' files packed successfully.';
   if Dlg_packall.bad <> 0 then
      report := report + IntToStr(Dlg_packall.bad) +
              ' files failed.';
   L_status.Caption := report;
end;

procedure TForm1.Btn_checkClick(Sender: TObject);
var
   table: string;
   errordir: string;
begin
   L_status.Caption := 'Checking '+ExtractFileName(FileListBox1.FileName)
                       + ' ...';
   L_status.Refresh;
   Screen.Cursor := crHourGlass;
   try
      try
         errordir := DirectoryListBox1.Directory;
         table := FreeFileExt(FileListBox1.FileName);
         RepairTable(table, errordir);
      except
         L_status.Caption :=
               'Check '+ExtractFileName(FileListBox1.FileName)+': Failed';
         MessageDlg(Exception(ExceptObject).Message, mtError, [mbOk], 0);
      end;
      L_status.Caption :=
            'Check '+ExtractFileName(FileListBox1.FileName) + ': Success';
   finally
      Screen.Cursor := crDefault;
   end;
end;

procedure TForm1.Btn_checkallClick(Sender: TObject);
var report: string;
begin
   Dlg_packall.Files := FileListBox1;
   Dlg_packall.Tag := 1; { Check identify }
   Dlg_packall.ShowModal;
   report := IntToStr(Dlg_packall.ckNoError)+ ' files good; ';
   {if Dlg_packall.ckVerifyError <> 0 then}
      report := report + IntToStr(Dlg_packall.ckVerifyError) +
              ' verify failed; ';
      report := report + IntToStr(Dlg_packall.ckRepaired) +
              ' repaired; ';
      report := report + IntToStr(Dlg_packall.ckDamaged) +
              ' damaged.';
   L_status.Caption := report;
end;

end.
